// Generated by dts-bundle-generator v9.0.0

declare enum TREE_ACTION_TRANSFER {
	ID = "id",
	PATH = "path",
	NODE = "node"
}
export interface AbstractTreeFactory {
	produce: (data: RawData[]) => AbstractTreeNode;
	initRoot: (rootInfo?: RootInfo) => AbstractTreeNode;
}
export interface AbstractTreeNode {
	id: string;
	name: string;
	parentId?: string;
	children: AbstractTreeNode[];
	parent?: AbstractTreeNode;
	level?: number;
	readonly root?: AbstractTreeNode;
	init: (props: TreeNodeProps) => this;
	setLevel: (val: number) => void;
	setParent: (data: AbstractTreeNode) => void;
	move: ({ from, to, type }: TransferParams) => number | undefined;
	swap: ({ from, to, type }: TransferParams) => number | undefined;
	removeChild: (id: string) => number | undefined;
	appendChild: (children: AbstractTreeNode[], index?: number) => number | undefined;
	findDeep: (id: string) => AbstractTreeNode | undefined;
	getRelativePath: () => string;
	toJSON: () => JSONData;
}
export interface JSONData extends Pick<AbstractTreeNode, "id" | "name" | "parentId" | "children" | "level"> {
}
export interface ProducedData extends RawData {
	children?: ProducedData[];
}
export interface RawData {
	id: string;
	name?: string;
	parentId?: string;
}
export interface RootInfo {
	id: string;
	name: string;
}
export interface TransferParams {
	from?: AbstractTreeNode | string;
	to: AbstractTreeNode | string;
	type?: TREE_ACTION_TRANSFER | string;
}
export interface TreeNodeProps extends Pick<AbstractTreeNode, "id" | "name" | "root" | "parent"> {
	parentId?: string;
	level: number;
	children?: AbstractTreeNode[];
}

export as namespace HierarchicalTree;

export {};
